unit Ukom;

interface

type
 PString=^TString;
 TString=record
  s:string;
  dalsi:PString;
 end;

 function Pridat(s:string;existPol:PString):PString;

 function StringDoCasu(s:string):TDateTime;
 function CasDoStringu(const c:TDateTime):string;

 procedure DekodujZpravu(zdroj:string; var typ,parametr:string);
 function DekodujRadek(const s:string):PString;
 function RozdelNaZpravy(co:string):PString;

 function JeToIP(s:string):boolean; {je v tom stringu ulozena IP adresa ?}


implementation

uses SysUtils, DateUtils;


function CasDoStringu(const c:TDateTime):string;
var rok,mesic,den,hod,min,sec,msec:word;
begin
DecodeDate(c,rok,mesic,den);
DecodeTime(c,hod,min,sec,msec);
result:=IntToStr(den)+'. '+IntToStr(mesic)+'. '+IntToStr(rok)+' '+
        IntToStr(hod)+':'+IntToStr(min);
end;

function StringDoCasu(s:string):TDateTime;
var i:integer;  rok,mesic,den,hod,min,sec,msec:word; a:string;
begin
try
result:=0;
i:=1;a:=''; repeat a:=a+s[i];i:=i+1 until (i>length(s))or(s[i]='.');
den:=StrToInt(a);i:=i+2;
if i>length(s)then exit;

a:=''; repeat a:=a+s[i];i:=i+1 until (i>length(s))or(s[i]='.');
mesic:=StrToInt(a);i:=i+2;
if i>length(s)then exit;

a:=''; repeat a:=a+s[i];i:=i+1 until (i>length(s))or(s[i]=' ');
rok:=StrToInt(a);i:=i+1;
if i>length(s)then exit;

a:=''; repeat a:=a+s[i];i:=i+1 until (i>length(s))or(s[i]=':');
hod:=StrToInt(a);i:=i+1;
if i>length(s)then exit;

a:=''; repeat a:=a+s[i];i:=i+1 until (i>length(s));
min:=StrToInt(a);

sec:=0;msec:=0;
result:=EncodeDateTime(rok,mesic,den,hod,min,sec,msec);
except result:=0 end;
end;



procedure DekodujZpravu(zdroj:string; var typ,parametr:string);
var i:integer;
begin
i:=1;
repeat
i:=i+1
until ((i>length(zdroj))or(zdroj[i]='='));

if i>length(zdroj)then
 begin
  typ:=''; parametr:='';  exit;
 end;

typ:=copy(zdroj,1,i-1);
parametr:=copy(zdroj,i+1,length(zdroj)-i);
end;


function DekodujRadek(const s:string):PString;
var i,posl:integer; pom:PString;
begin
result:=nil; posl:=1;
for i:=1 to length(s)do
 if s[i]=';' then
  begin
   pom:=Pridat(copy(s,posl,i-posl),result);
   if result=nil then result:=pom;
   posl:=i+1;
  end;
end;


function RozdelNaZpravy(co:string):PString;
var i:integer;  posledni_lomitko:integer;  pom:PString;
begin
result:=nil; posledni_lomitko:=1;
for i:=1 to length(co) do
 if co[i]='\' then
  begin
   pom:=Pridat(copy(co,posledni_lomitko,i-posledni_lomitko),result);
   if result=nil then result:=pom;
   posledni_lomitko:=i+1;
  end;
end;



{prida polozku do linearniho seznamu stringu}
function Pridat(s:string;existPol:PString):PString;
var n:PString; akt:PString;
begin
new(n); n^.s:=s; n^.dalsi:=nil; result:=n;
if existPol=nil then exit;

akt:=existPol; while akt^.dalsi<>nil do akt:=akt^.dalsi;
akt^.dalsi:=n;
end;




function JeToIP(s:string):boolean;
var i,pom:integer;  ps:string;
begin
result:=true;

pom:=0;
for i:=1 to length(s)do
 begin
  if s[i]='.' then pom:=pom+1;
  if not (s[i] in ['.','0','1','2','3','4','5','6','7','8','9']) then
    begin result:=false;exit;end;
 end;

if pom<>3 then begin result:=false;exit;end;

ps:='';
for i:=1 to length(s)+1 do
 if (s[i]='.')or(i=length(s)+1)then
  begin
    try pom:=StrToInt(ps);except result:=false;exit;end;
    if (pom<0)or(pom>255)then begin result:=false;exit;end;
    ps:='';
  end
 else ps:=ps+s[i];
end;



end.
