unit ukino;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, Grids, ComCtrls, StdCtrls, Spin, ExtCtrls, ukom;

type

 PSedadlo=^TSedadlo; {typ oznacujici sedadlo}
 TSedadlo=record
  x,y:integer;   {poloha sedadla v sale}
  dalsi:PSedadlo;
 end;

 PPredst=^TPredst;
 TPredst=record   {typ predstavujici konkretni predstaveni}
  nazev,cena:string; {nazev a cena konkretniho predstaveni}
  cas:TDateTime;     {zacatek konkretniho predstaveni}
  dalsi:PPredst;
 end;

 TAktSal=record {aktualne vybrany sal}
  nazev:string;
  x,y:integer; {sirka a vyska}
  neex:PSedadlo; {neexistujici sedadla}
  predst:PPredst; {seznam konkretnich predstaveni v sale}
 end;

 TAktPred=record   {aktualne vybrane predstaveni}
  nazev,cena:string; {nazev a cena}
  cas:TDate;     {zacatek}
  obs:PSedadlo; {obsazena sedadla}
  cekani:boolean; {jeste neprisla od salu obsazena sedadla}
 end;

type
  TForm1 = class(TForm)
    cs: TClientSocket;
    sg: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    pb: TPaintBox;
    Button4: TButton;
    Button6: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lcena: TLabel;
    lpocet: TLabel;
    lccena: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lvolna: TLabel;
    lobsazena: TLabel;
    lcelkem: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    status: TLabel;
    re: TRichEdit;
    lbsaly: TListBox;
    CheckBox1: TCheckBox;
    linfo: TLabel;
    procedure OznacKP;
    procedure VykresliKP;
    procedure VymazKPredstaveni;
    procedure VymazTabulky;
    procedure VymazData;
    procedure ObnovNapisy;
    procedure VynulujNapisy;
    procedure VytiskniVstupenku(sal,nazev,cena,prodavajici:string;
                                   zacatek:TDateTime; rada,sedadlo:integer);
    procedure FormResize(Sender: TObject);
    procedure csDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure csConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure csError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure csRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure pbPaint(Sender: TObject);
    procedure pbMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sgClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure lbsalyClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure reMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pbMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  AktSal:TAktSal; {aktualni sal}
  AktPred:TAktPred; {aktualni predstaveni}

  oznacene:PSedadlo; {linearni seznam oznacenych sedadel}


implementation

{$R *.dfm}

uses uprip;


procedure Znicit(var u:PString);overload;{znici linearni seznam stringu}
begin
if u<>nil then
 begin
  Znicit(u^.dalsi);Dispose(u);u:=nil;
 end;
end;

procedure Znicit(var u:PSedadlo);overload;
begin
if u<>nil then
 begin
  Znicit(u^.dalsi);Dispose(u);u:=nil;
 end;
end;

procedure Znicit(var u:PPredst);overload;
begin
if u<>nil then
 begin
  Znicit(u^.dalsi);Dispose(u);u:=nil;
 end;
end;



procedure TForm1.VymazKPredstaveni;
var myRect:TGridRect;
begin
myRect:=sg.Selection; myRect.Top:=1;myRect.Bottom:=1; sg.Selection:=myRect;
sg.RowCount:=2;  sg.Cells[0,1]:=''; sg.Cells[1,1]:=''; sg.Cells[2,1]:='';
end;


procedure TForm1.VymazTabulky;
begin
lbsaly.Clear;
VymazKPredstaveni;
end;


procedure TForm1.VynulujNapisy;
begin
form1.lcena.Caption:='';
form1.lpocet.Caption:='';
form1.lccena.Caption:='';
form1.lvolna.Caption:='';
form1.lobsazena.Caption:='';
form1.lcelkem.Caption:='';
end;


procedure TForm1.VymazData;
begin
AktSal.nazev:='';AktSal.x:=0;AktSal.y:=0;
Znicit(AktSal.neex);Znicit(AktSal.predst);
AktPred.nazev:=''; AktPred.cena:=''; AktPred.cas:=0; AktPred.cekani:=false;
Znicit(AktPred.obs);Znicit(oznacene);
end;


{je sedadlo na teto souradnici oznacene?}
function JeOznacene(x,y:integer):boolean;
var akt:PSedadlo;
begin
result:=false;
akt:=oznacene;
while akt<>nil do
 begin
  if (akt^.x=x)and(akt^.y=y)then begin result:=true;exit;end;
  akt:=akt^.dalsi;
 end;
end;

{je sedadlo na teto souradnici obsazene?}
function JeObsazene(x,y:integer):boolean;
var akt:PSedadlo;
begin
result:=false;
akt:=AktPred.obs;
while akt<>nil do
 begin
  if (akt^.x=x)and(akt^.y=y)then begin result:=true;exit;end;
  akt:=akt^.dalsi;
 end;
end;

{je sedadlo na teto souradnici neexistujici?}
function Neexistuje(x,y:integer):boolean;
var akt:PSedadlo;
begin
result:=false;
akt:=AktSal.neex;
while akt<>nil do
 begin
  if (akt^.x=x)and(akt^.y=y)then begin result:=true;exit;end;
  akt:=akt^.dalsi;
 end;
end;


{prida konkretni predstaveni do seznamu v AktSal}
procedure PridejKP(s1,s2,s3:string);
var n:PPredst;
begin
New(n); n^.nazev:=s1; n^.cas:=StringDoCasu(s2); n^.cena:=s3;
n^.dalsi:=AktSal.predst; AktSal.predst:=n;
end;

{nastavi sedadlo na neexistujici}
procedure PridejNeex(x,y:integer);
var n:PSedadlo;
begin
new(n); n^.x:=x; n^.y:=y;
n^.dalsi:=AktSal.neex; AktSal.neex:=n;
end;

{nastavi sedadlo na obsazene}
procedure PridejObs(x,y:integer);
var n:PSedadlo;
begin
new(n); n^.x:=x; n^.y:=y;
n^.dalsi:=AktPred.obs; AktPred.obs:=n;
end;




procedure ProvedPrikaz(typ,par:string;socket:TCustomWinSocket);
var pom,akt:PString; s1,s2,s3:string;
begin
if typ='login'then
 begin
  form1.cs.Socket.SendText('login='+form2.LabeledEdit1.Text+';'+
   form2.LabeledEdit2.Text+';\');
 end
else
if typ='badname'then
 begin
  form1.cs.Socket.Close;
  MessageDlg('patn uivatelsk jmno !',mtError,[mbOk],0);
 end
else
if typ='uzprip'then
 begin
  form1.cs.Socket.Close;
  MessageDlg('Uivatel s takovm uivatelskm jmnem je ji pipojen !',mtError,[mbOk],0);
 end
else
if typ='badpass'then
 begin
  form1.cs.Socket.Close;
  MessageDlg('patn heslo !',mtError,[mbOk],0);
 end
else
if typ='odpojit' then
 begin
  form1.cs.Active:=false; {form1.cs.Socket.Close;}
 end
else
if typ='saly'then
 begin
  pom:=DekodujRadek(par);
  form1.lbsaly.Items.BeginUpdate; form1.lbsaly.Clear;
  {naplneni listboxu daty, co prisly}
  while pom<>nil do begin form1.lbsaly.Items.Add(pom^.s); pom:=pom^.dalsi;end;
  {nastavim aktualni index v listboxu podle AktSal.nazev}
  form1.lbsaly.ItemIndex:=form1.lbsaly.Items.IndexOf(AktSal.nazev);
  form1.lbsaly.Items.EndUpdate;
  {kdyz nebyl sal oznacen a je neco v AktSal.nazev}
  if(form1.lbsaly.ItemIndex<0)and(AktSal.nazev<>'')then
   begin
    form1.lbsalyClick(nil);
   end;
  Znicit(pom);
 end
else
if typ='salkpall'then
 begin {naplneni aktsalu seznamem konkretnich predstaveni}
  pom:=DekodujRadek(par); akt:=pom;
  if akt^.s<>AktSal.nazev then begin Znicit(pom);exit;end;{jiny sal => nezajima}
  akt:=akt^.dalsi;  Znicit(AktSal.predst);
  while akt<>nil do
   begin
    s1:=akt^.s; akt:=akt^.dalsi;
    s2:=akt^.s; akt:=akt^.dalsi;
    s3:=akt^.s; akt:=akt^.dalsi;
    PridejKP(s1,s2,s3);
   end;
  form1.VykresliKP;
  form1.OznacKP;
  if AktPred.nazev='' then form1.sgClick(nil);
  Znicit(pom);
 end
else
if typ='salneex'then
 begin {naplneni aktsalu - rozmery salu a seznam neexistujicich sedadel}
  pom:=DekodujRadek(par); akt:=pom;
  if akt^.s<>AktSal.nazev then begin Znicit(pom);exit;end;
  akt:=akt^.dalsi;
  AktSal.x:=StrToInt(akt^.s); akt:=akt^.dalsi;
  AktSal.y:=StrToInt(akt^.s); akt:=akt^.dalsi;
  Znicit(AktSal.neex);
  while akt<>nil do
   begin
    s1:=akt^.s; akt:=akt^.dalsi; s2:=akt^.s;
    PridejNeex(StrToInt(s1),StrToInt(s2));
    akt:=akt^.dalsi;
   end;
  Znicit(pom);
  form1.pb.Repaint;
 end
else
if typ='salkp'then
 begin  {seznam obsazenych sedadel na konkretni predstaveni}
  pom:=DekodujRadek(par); akt:=pom;
  if akt^.s<>AktSal.nazev then begin Znicit(pom);exit;end;
  akt:=akt^.dalsi; s1:=akt^.s; akt:=akt^.dalsi; s2:=akt^.s;   akt:=akt^.dalsi;
  if (s1+s2)<>(AktPred.nazev+CasDoStringu(AktPred.cas))then
   begin Znicit(pom);exit;end;
  AktPred.cekani:=false;
  Znicit(AktPred.obs);
  while akt<>nil do
   begin
    s1:=akt^.s; akt:=akt^.dalsi; s2:=akt^.s;
    PridejObs(StrToInt(s1),StrToInt(s2));
    akt:=akt^.dalsi;
   end;
  Znicit(pom);
  form1.ObnovNapisy;
  form1.pb.Repaint;
 end
else
if typ='buyprint'then
 begin
  pom:=DekodujRadek(par);
  akt:=pom; while akt^.dalsi^.dalsi^.dalsi<>nil do akt:=akt^.dalsi;

  Form1.VytiskniVstupenku(pom^.s,pom^.dalsi^.s,pom^.dalsi^.dalsi^.dalsi^.s,
   form2.LabeledEdit1.Text,StringDoCasu(pom^.dalsi^.dalsi^.s),
   StrToInt(akt^.s),StrToInt(akt^.dalsi^.s));
   
  Znicit(pom);
 end;

end;




{zmena rozmeru formulare}
procedure TForm1.FormResize(Sender: TObject);
begin
sg.Height:=form1.ClientHeight-sg.Top-9;
pb.Height:=form1.ClientHeight-pb.Top-9;
pb.Width:=form1.ClientWidth-pb.Left-11;
end;

{odpojeni od serveru}
procedure TForm1.csDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
status.Caption:='nepipojeno';
VynulujNapisy; VymazData; VymazTabulky;
pb.Repaint;
end;

{pripojeni k serveru}
procedure TForm1.csConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
status.Caption:='pipojeno';
end;

{chyba pri komunikaci po TCP/IP}
procedure TForm1.csError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
ErrorCode:=0; socket.Close;
MessageDlg('Chyba pi komunikaci po TCP/IP !',mtError,[mbOk],0);
end;

{prijmuti zpravy}
procedure TForm1.csRead(Sender: TObject; Socket: TCustomWinSocket);
var prijato,typ,par:string; zpravy,akt:PString; 
begin
prijato:=socket.ReceiveText;

while Length(prijato)>0 do
begin
zpravy:=RozdelNaZpravy(prijato);
akt:=zpravy;
while akt<>nil do
 begin
  DekodujZpravu(akt^.s,typ,par);
  ProvedPrikaz(typ,par,socket);
  akt:=akt^.dalsi;
 end;
prijato:=socket.ReceiveText;
end;
Znicit(zpravy);
end;


{prekresleni salu}
procedure TForm1.pbPaint(Sender: TObject);
var i,ii,st,vt:integer; ss,vs,x,y:real;  t:string;
begin
pb.Canvas.Pen.Width:=2;
pb.Canvas.Pen.Color:=clBlue;
pb.Canvas.Brush.Style:=bsSolid;
pb.Canvas.Brush.Color:=clBlack;
pb.Canvas.Rectangle(1,1,pb.ClientWidth-1,pb.ClientHeight-1);

pb.Canvas.Pen.Width:=1;
pb.Canvas.Pen.Color:=clWhite;
pb.Canvas.Font.Name:='Arial';
pb.Canvas.Font.Size:=14;
pb.Canvas.Font.Color:=clWhite;
pb.Canvas.Brush.Color:=clBlue;
t:='promtac pltno'; st:=pb.Canvas.TextWidth(t);
 vt:=pb.Canvas.TextHeight(t);  {vyska textu}

pb.Canvas.Rectangle((pb.ClientWidth-st)div 2-2,pb.ClientHeight-20-vt div 2-1,
                    (pb.ClientWidth+st)div 2+2,pb.ClientHeight-20+vt div 2+1);

pb.Canvas.TextOut((pb.ClientWidth-st)div 2,pb.ClientHeight-20-vt div 2,t);

if (AktPred.Nazev='')or(AktPred.cekani) then exit;


ss:=(pb.ClientWidth-20)/(AktSal.x+(AktSal.x-1)/2);  {sirka sedadla}
vs:=(pb.ClientHeight-20-vt-5)/(AktSal.y+(AktSal.y-1)/2); {vyska sedadla}

x:=10;
for i:=1 to AktSal.x do
 begin
  y:=10;
  for ii:=1 to AktSal.y do
   begin
     if Neexistuje(i,ii)then
      begin
       pb.Canvas.Brush.Color:=clBlack;
       pb.Canvas.Pen.Color:=clBlack;
      end
     else
      begin
       if JeOznacene(i,ii)then pb.Canvas.Pen.Color:=clBlue
        else pb.Canvas.Pen.Color:=clWhite;
       if JeObsazene(i,ii)then pb.Canvas.Brush.Color:=clRed
       else pb.Canvas.Brush.Color:=clGreen;
      end;
    pb.Canvas.Rectangle(Round(x),Round(y),Round(x+ss),round(y+vs));
    y:=y+vs*1.5
   end;
  x:=x+ss*1.5;
 end;

end;



procedure TForm1.pbMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ss,vs,rx,ry:real; psed,pr:PSedadlo;  sx,sy,vt:integer;
begin
if (AktPred.nazev='')or(AktSal.nazev='') then exit;

{zjisteni vysky a sirky sedadla}
pb.Canvas.Font.Name:='Arial';pb.Canvas.Font.Size:=14;
vt:=pb.Canvas.TextHeight('promtac pltno');
ss:=(pb.ClientWidth-20)/(AktSal.x+(AktSal.x-1)/2);
vs:=(pb.ClientHeight-20-vt-5)/(AktSal.y+(AktSal.y-1)/2);
{END of zjisteni...}


x:=x-10;
sx:=Trunc(x/(ss+ss/2))+1;
{if (x mod Round(ss+ss/2))>ss then exit;}
rx:=x;
while rx>(ss+ss/2)do rx:=rx-(ss+ss/2);
if rx>ss then exit;

y:=y-10;
sy:=Trunc(y/(vs+vs/2))+1;
{if (y mod Round(vs+vs/2))>vs then exit;}
ry:=y;
while ry>(vs+vs/2)do ry:=ry-(vs+vs/2);
if ry>vs then exit;

if (sx>AktSal.x)or(sy>AktSal.y)then exit;
if Neexistuje(sx,sy)then exit;


if oznacene<>nil then
 begin
  if (JeObsazene(oznacene^.x,oznacene^.y))and(not JeObsazene(sx,sy))then exit;
  if (not JeObsazene(oznacene^.x,oznacene^.y))and(JeObsazene(sx,sy))then exit;  
 end;

if JeOznacene(sx,sy)then
 begin {odoznaceni}
  pr:=nil;psed:=oznacene;
  while (psed^.x<>sx)and(psed^.y<>sy) do begin pr:=psed;psed:=psed^.dalsi;end;
  if pr=nil then  begin oznacene:=psed^.dalsi; dispose(psed);end
            else  begin pr^.dalsi:=psed^.dalsi; dispose(psed);end;
 end
else
 begin {oznaceni}
  New(psed);psed^.x:=sx;psed^.y:=sy; psed^.dalsi:=oznacene; oznacene:=psed;
 end;

ObnovNapisy;
pb.Repaint;
end;




procedure TForm1.pbMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var vt,sx,sy:integer;  ss,vs,rx,ry:real;

  {aby to neproblikavalo}
  procedure ZmenNapis(novy:string);
   begin  if linfo.Caption<>novy then linfo.Caption:=novy; end;

begin

if (AktPred.nazev='')or(AktSal.nazev='') then
 begin ZmenNapis(''); exit;end;

{zjisteni vysky a sirky sedadla}
pb.Canvas.Font.Name:='Arial';pb.Canvas.Font.Size:=14;
vt:=pb.Canvas.TextHeight('promtac pltno');
ss:=(pb.ClientWidth-20)/(AktSal.x+(AktSal.x-1)/2);
vs:=(pb.ClientHeight-20-vt-5)/(AktSal.y+(AktSal.y-1)/2);
{END of zjisteni...}


x:=x-10;
sx:=Trunc(x/(ss+ss/2))+1;
{if (x mod Round(ss+ss/2))>ss then exit;}
rx:=x;
while rx>(ss+ss/2)do rx:=rx-(ss+ss/2);

if rx>ss then begin ZmenNapis(''); exit;end;


y:=y-10;
sy:=Trunc(y/(vs+vs/2))+1;
{if (y mod Round(vs+vs/2))>vs then exit;}
ry:=y;
while ry>(vs+vs/2)do ry:=ry-(vs+vs/2);

if ry>vs then begin ZmenNapis(''); exit;end;


if (sx>AktSal.x)or(sy>AktSal.y)then  begin ZmenNapis(''); exit;end;

ZmenNapis(
'ada: '+IntToStr(AktSal.y-sy+1)+'   '+
'Sedadlo: '+IntToStr(AktSal.x-sx+1)
);

end;








{tlacitko PRIPOJIT}
procedure TForm1.Button1Click(Sender: TObject);
begin
if cs.Active then MessageDlg('U jste pipojen !',mtWarning,[mbOk],0)
else form2.ShowModal;
end;

{tlacitko ODPOJIT}
procedure TForm1.Button2Click(Sender: TObject);
begin
cs.Active:=false;
pb.Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
sg.Cells[0,0]:='nzev pedstaven';
sg.Cells[1,0]:='zatek';
sg.Cells[2,0]:='cena';
VynulujNapisy; VymazData;
end;


{kliknuti na seznam predstaveni}
procedure TForm1.sgClick(Sender: TObject);
begin
if not cs.Active then exit;
Znicit(oznacene);VynulujNapisy;

AktPred.nazev:=''; AktPred.cas:=0; AktPred.cena:='';
if (sg.Selection.Top>0)and(sg.Cells[0,1]<>'') then
 begin
  AktPred.nazev:=sg.Cells[0,sg.Selection.Top];
  AktPred.cas:=StrToDateTime(sg.Cells[1,sg.Selection.Top]);
  AktPred.cena:=sg.Cells[2,sg.Selection.Top];
  AktPred.cekani:=true;

  cs.Socket.SendText('salkp='+AktSal.nazev+';'+AktPred.nazev+';'
                      +CasDoStringu(AktPred.cas)+';\');
 end;
pb.Repaint;
end;



{tlacitko KOUPIT}
procedure TForm1.Button4Click(Sender: TObject);
var ps:PSedadlo; s,t,tr,ts:string;
begin
if not cs.Active then exit;
if (AktSal.nazev='')or(AktPred.nazev='')or(AktPred.cas=0)then exit;
if oznacene=nil then exit;
if JeObsazene(oznacene^.x,oznacene^.y)then
 begin
  MessageDlg('Mte oznaena obsazen sedadla !',mtWarning,[mbOk],0);exit;
 end;

s:='buy='+AktSal.nazev+';'+AktPred.nazev+';'+CasdoStringu(AktPred.cas)+';'+
   AktPred.cena+';';
if CheckBox1.Checked then t:='1' else t:='0';
ps:=oznacene;
while ps<>nil do
 begin
  if (not Neexistuje(ps^.x,ps^.y))and(not JeObsazene(ps^.x,ps^.y))then
   begin
    tr:=IntToStr(AktSal.y-ps^.y+1);{rada}
    ts:=IntToStr(AktSal.x-ps^.x+1);{sedadlo}
    cs.Socket.SendText(s+IntToStr(ps^.x)+';'+IntToStr(ps^.y)+';'+tr+';'+ts+';'+t+';\');
   end;
  ps:=ps^.dalsi;
 end;

Znicit(oznacene);
sgClick(nil);
ObnovNapisy;
pb.Repaint;
end;



{tlacitko ZRUSIT KOUPI}
procedure TForm1.Button6Click(Sender: TObject);
var ps:PSedadlo; s:string;
begin
if not cs.Active then exit;
if (AktSal.nazev='')or(AktPred.nazev='')or(AktPred.cas=0)then exit;
if oznacene=nil then exit;
if not JeObsazene(oznacene^.x,oznacene^.y)then
 begin
  MessageDlg('Mte oznaena voln sedadla !',mtWarning,[mbOk],0);exit;
 end;

s:='unbuy='+AktSal.nazev+';'+AktPred.nazev+';'+CasdoStringu(AktPred.cas)+';';
ps:=oznacene;
while ps<>nil do
 begin
  if (not Neexistuje(ps^.x,ps^.y))and(JeObsazene(ps^.x,ps^.y))then
    cs.Socket.SendText(s+IntToStr(ps^.x)+';'+IntToStr(ps^.y)+';\');
  ps:=ps^.dalsi;
 end;

Znicit(oznacene);
sgClick(nil);
ObnovNapisy;
pb.Repaint;
end;



procedure TForm1.VytiskniVstupenku(sal,nazev,cena,prodavajici:string;
                                    zacatek:TDateTime; rada,sedadlo:integer);
begin
re.Lines.Clear;
re.Font.Name:='Arial';re.Font.Color:=clBlack;re.Font.Size:=16;re.Font.Style:=[];
re.SelAttributes.Name:='Arial';re.SelAttributes.Color:=clBlack;re.SelAttributes.Size:=16;re.SelAttributes.Style:=[];
re.SelAttributes.Size:=14;
re.Lines.Add(sal);
re.SelAttributes.Size:=18; re.SelAttributes.Style:=[fsBold];
re.Lines.Add('   '+nazev);
re.SelAttributes.Size:=12;re.SelAttributes.Style:=[];
re.Lines.Add('zatek: '+DateToStr(zacatek)+' '+TimeToStr(zacatek));
re.SelAttributes.Size:=4;re.Lines.Add('');
re.SelAttributes.Size:=12;
re.Lines.Add('ada: '+IntToStr(rada)+'     sedadlo: '+IntToStr(sedadlo));
re.SelAttributes.Size:=4;re.Lines.Add('');
re.SelAttributes.Size:=10;
re.Lines.Add('cena: '+cena+'K');
re.SelAttributes.Size:=4;re.Lines.Add('');
re.SelAttributes.Size:=9;
re.Lines.Add('prodal(a) '+prodavajici+'  '+DateToStr(now)+' '+TimeToStr(now));
re.Print('Kino 2002 - vstupenka');
end;



{kliknuti na seznam salu}
procedure TForm1.lbsalyClick(Sender: TObject);
begin
if not cs.Active then exit;
Znicit(oznacene);VynulujNapisy;

VymazKPredstaveni;

AktSal.nazev:=''; Znicit(AktSal.neex); Znicit(AktSal.predst);
AktPred.nazev:=''; Znicit(AktPred.obs);

if lbsaly.ItemIndex>=0 then
 begin
  AktSal.nazev:=lbsaly.Items[lbsaly.itemIndex];
  cs.Socket.SendText('sal='+AktSal.nazev+';\');
 end;
pb.Repaint;
end;



procedure TForm1.VykresliKP;
var kp:PPredst; i,mez,nejm:integer;

 procedure Prohod(j,d:integer);
  var s1,s2,s3:string;
  begin
   s1:=sg.Cells[0,j]; s2:=sg.Cells[1,j]; s3:=sg.Cells[2,j];
   sg.Cells[0,j]:=sg.Cells[0,d];  sg.Cells[1,j]:=sg.Cells[1,d];
   sg.Cells[2,j]:=sg.Cells[2,d];
   sg.Cells[0,d]:=s1; sg.Cells[1,d]:=s2; sg.Cells[2,d]:=s3;
  end;

begin
VymazKPredstaveni;
kp:=AktSal.predst; i:=-1;
while kp<>nil do
 begin
  if sg.Cells[0,1]<>'' then sg.RowCount:=sg.RowCount+1;
  sg.Cells[0,sg.RowCount-1]:=kp^.nazev;
  sg.Cells[1,sg.RowCount-1]:=DateTimeToStr(kp^.cas);
  sg.Cells[2,sg.RowCount-1]:=kp^.cena;
  if (AktPred.nazev=kp^.nazev)and(AktPred.cas=kp^.cas)and(AktPred.cena=kp^.cena)
   then i:=sg.RowCount-1;
  kp:=kp^.dalsi;
 end;
if i<0 then  begin AktPred.nazev:=''; AktPred.cas:=0; end;

{razeni primym vyberem}
for mez:=1 to sg.RowCount-2 do
 begin
  nejm:=mez;
  for i:=mez+1 to sg.RowCount-1 do
   if StrToDateTime(sg.Cells[1,i])<StrToDateTime(sg.Cells[1,nejm])then nejm:=i;
  Prohod(nejm,mez);
 end;

end;



procedure TForm1.OznacKP;
var myRect:TGridRect; i:integer;
begin
myRect:=sg.Selection; myRect.Top:=-1;myRect.Bottom:=-1; sg.Selection:=myRect;

{v seznamu neni zadne predstaveni nebo neni vybrano zadne aktualni}
if (sg.Cells[0,1]='')or(AktPred.nazev='') then
 begin Znicit(AktPred.obs);AktPred.nazev:='';AktPred.cekani:=false; exit;end;

for i:=1 to sg.RowCount-1 do
 begin
 {najdu v seznamu aktualni predstaveni => oznacim ho}
  if (sg.Cells[0,i]+sg.Cells[1,i])=(AktPred.nazev+DateTimeToStr(AktPred.cas))then
   begin
    myRect.Top:=i; myRect.Bottom:=i; sg.Selection:=myRect; exit;
   end;
 end;
{aktualni predstaveni jsem nenasel}
Znicit(AktPred.obs); AktPred.nazev:=''; AktPred.cekani:=false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Znicit(AktSal.neex); Znicit(AktSal.Predst); Znicit(AktPred.obs);
Znicit(oznacene);
end;


procedure TForm1.ObnovNapisy;

 function PocetOznacenych:integer;
  var p:PSedadlo;
  begin
   p:=oznacene; result:=0;
   while p<>nil do begin result:=result+1; p:=p^.dalsi;end;
  end;

 function PocetObsazenych:integer;
  var p:PSedadlo;
  begin
   p:=AktPred.obs; result:=0;
   while p<>nil do begin result:=result+1; p:=p^.dalsi;end;
  end;

 function PocetCelkovy:integer;
  var p:PSedadlo;
  begin
   result:=AktSal.x*AktSal.y;   p:=AktSal.neex;
   while p<>nil do begin result:=result-1; p:=p^.dalsi;end;
  end;

begin
VynulujNapisy;
if (AktPred.nazev='')or(AktPred.cekani)then exit;
lcena.Caption:=AktPred.cena+' K';
lpocet.Caption:=IntToStr(PocetOznacenych);
lccena.Caption:=IntToStr(StrToInt(AktPred.cena)*PocetOznacenych)+' K';

lcelkem.Caption:=IntToStr(PocetCelkovy);
lobsazena.Caption:=IntToStr(PocetObsazenych);
lvolna.Caption:=IntToStr(StrToInt(lcelkem.Caption)-StrToInt(lobsazena.Caption));

end;


procedure TForm1.reMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
re.Visible:=false;
end;



end.
