unit Userver;

interface

uses ScktComp, StdCtrls, Grids, Classes;

type
 PUzivatel=^TUzivatel;
 TUzivatel=record {typ predstavujici uzivatele}
  jmeno,heslo:string; {uzivatelske jmeno a heslo}
  psat:boolean;  {muze kupovat vstupenky?}
  socket:TCustomWinSocket;{socket, na kterem je uzivatel pripojen; nil=nepripojen}
  dalsi:PUzivatel; {je to linearni seznam}
 end;

 PSedadlo=^TSedadlo; {typ predstavujici sedadlo}
 TSedadlo=record
  x,y:integer; {poloha sedadla v sale}
  dalsi:PSedadlo;
 end;

 PPredstaveni=^TPredstaveni;
 TPredstaveni=record {typ predstavujici predstaveni}
  nazev,zanr,popis,poznamka,delka:string; {udaje o predstaveni}
  dalsi:PPredstaveni;
 end;

 PKPredstaveni=^TKPredstaveni;{konkretni predstaveni}
 TKPredstaveni=record
  nazev:string;{odpovida nazvu predstaveni; puvodne to mel byt ukazatel, ale}
               {nakonec se ukazalo, ze to bude lepsi takhle}
  cena:string; {puvodne aby tam mohla byt i mna}
               {kvuli pocitani u clienta tam stejne davam integry}
  zacatek:TDateTime; {zacatek predstaveni}
  obsazene:PSedadlo; {seznam obsazenych sedadel}
  dalsi:PKPredstaveni;
 end;

 PSal=^TSal;
 TSal=record  {sal}
  nazev:string; {nazev salu}
  x,y:integer; {rozmery salu}
  neex:PSedadlo; {neexistujici sedadla}
  kpred:PKPredstaveni; {konkretni predstaveni v sale}
  {konkretni predstaveni je jednoznacne dano svym nazvem a zacatkem}
  dalsi:PSal;
 end;




 {trida, jejiz jedna instance se pouzije v hlavnim programu}
 TServer=class

  uzivatele:PUzivatel; {seznam uzivatelu}
  predstaveni:PPredstaveni; {seznam predstaveni}
  saly:PSal; {seznam salu}


  constructor Vytvor; {nacte uzivatele, predstaveni a saly ze souboru}
  destructor Znic; {znici uzivatele, predstaveni a saly}
  function NepovolenyZnak(s:string):boolean;{obsahuje retezec nepovoleny znak?}

{procedury a funkce tykajici se uzivatelu}
  {existuje uzivatel tohoto jmena?}
  function UzivatelExistuje(jm:string):boolean;
  {prida uzivatele; false=takovy uzivatel jiz existuje}
  function UzivatelPridat(jm,h:string;p:boolean):boolean;
  {upravi uzivatele; false=takove uzivatelske jmeno jiz existuje}
  function UzivatelUpravit(sjm,jm,h:string;p:boolean):boolean;
  {smaze uzivatele; false=takovy uzivatel neexistuje}
  function UzivatelSmazat(jm:string):boolean;
  {zda muze uzivatel kupovat a odkupovat vstupenky}
  function UzivatelMuzePsat(soc:TCustomWinSocket):boolean;
  {je uzivatel pripojen?}
  function UzivatelPripojen(jm:string):boolean;
  {vrati ukazatel na uzivatele; nil=nenalezen}
  function Uzivatel(jm:string):PUzivatel;overload;
  function Uzivatel(soc:TCustomWinSocket):PUzivatel;overload;
  {naplni Items listboxu jmeny uzivatelu}
  procedure UzivateleVsichni(var lb:TListBox);
  {ulozi uzivatele do souboru}
  function UzivateleUloz:boolean;


{procedury a funkce tykajici se salu a konkretnich predstaveni (jsou v salech)}
  {existuje sal tohoto jmena?}
  function SalExistuje(jm:string):boolean;
  {vytvori sal daneho jmena a rozmeru; false=uz takovy existuje}
  function SalPridat(jm: string;x,y:integer):boolean;
  {prejmenuje sal; false=sal s takovym jmenem uz existuje}
  function SalPrejmenovat(sjm,jm:string):boolean;
  {zmeni rozmery salu; false=sal nenalezen}
  function SalRozmery(nazev:string;x,y:integer):boolean;
  {smaze sal; false=sal nenalezen}
  function SalSmazat(jm:string):boolean;
  {vrati ukazatel na sal; nil=nenalezen}
  function Sal(jm:string):PSal;
  {prida do salu neexistujici sadadlo}
  function SalPridatNeex(nazev:string;x,y:integer):boolean;
  {smaze ze salu neexistujici sedadlo}
  function SalSmazatNeex(nazev:string;x,y:integer):boolean;
  {result=je toto sedadlo nastaveno na neexistujici}
  function SalExistNeex(nazev:string;x,y:integer):boolean;
  {naplni Items listboxu jmeny salu}
  procedure SalyVsechny(var lb:TListBox);
  {ulozi saly do souboru}
  function SalyUloz:boolean;

   {existuje konkretni predstaveni v tomto sale?}
   function KPredstaveniExistuje(jmsal,jm:string;zac:TDateTime):boolean;
   {prida konkretni predstaveni do salu}
   function KPredstaveniPridat(jmsal,jm,cena:string;zac:TDateTime):boolean;
   {smaze konkretni predstaveni ze salu}
   function KPredstaveniSmazat(jmsal,jm:string;zac:TDateTime):boolean;
   {upravi konkretni predstaveni}
   function KPredstaveniUpravit(jmsal,sjm,jm,cena:string;szac,zac:TDateTime):boolean;
   {vrati ukazatel na konkretni predstaveni; nil=nenalezeno}
   function KPredstaveniJedno(jmsal,jm:string;zac:TDateTime):PKPredstaveni;
   {naplni StringGrid udaji o konkretnich predstaveni ze zadaneho salu}
   procedure KPredstaveniVsechny(jmsal:string;var s:TStringGrid);
   {oznaci sedadlo [x,y] za prodane}
   function KPredstaveniKoupit(jmsal,jm,zac:string;x,y:integer):boolean;
   {oznaci sedadlo [x,y] za volne}
   function KPredstaveniOdkoupit(jmsal,jm,zac:string;x,y:integer):boolean;


{procedury a funkce tykajici se predstaveni}
  {existuje predstaveni tohoto jmena?}
  function PredstaveniExistuje(jm: string): boolean;
  {prida predstaveni}
  function PredstaveniPridat(nazev,zanr,delka,popis,poznamka:string):boolean;
  {smaze predstaveni}
  function PredstaveniSmazat(jm: string): boolean;
  {upravi predstaveni}
  function PredstaveniUpravit(sjm,nazev,zanr,delka,popis,poznamka:string):boolean;
  {naplni Items listboxu nebo comboboxu nazvy predstaveni}
  procedure PredstaveniVsechny(var lb:TListBox); overload;
  procedure PredstaveniVsechny(var lb:TComboBox); overload;  
  {vrati ukazatel na predstaveni}
  function PredstaveniJedno(jm:string):PPredstaveni;
  {ulozi predstaveni do souboru}
  function PredstaveniUloz:boolean;


{procedury a funkce tykajici se hlavne komunikace}
  {odesle string vsem klientum}
  procedure OdeslatVsem(co:string);
  {vrati string, ktery obsahuje seznam salu ve tvaru urcenem pro prenos po siti}
  function NapisSaly:string;
  {seznam konkretnich predstaveni v danem sale}
  function NapisKPVse(s:string):string;
  {seznam neexistujicich sedadel v danem sale}
  function NapisNeex(s:string):string;
  {seznam obsazenych sedadel na konkretni predstaveni}
  function NapisKP(sal,nazev,cas:string):string;

 end;



implementation

{ TServer }
uses uXMLpar, SysUtils, DateUtils, UKom;


function TServer.NepovolenyZnak(s: string): boolean;
var i:integer;
begin
result:=true;
for i:=1 to length(s) do  if s[i]in['"',';','\']then exit;
result:=false;
end;




constructor TServer.Vytvor;
var t,kam,kam2:PTag; f:TextFile; i:integer;
    jm,h,nazev,nazevpr,zanr,delka,popis,pozn,cena,zacatek,x,y:string; p:boolean;
begin
uzivatele:=nil; predstaveni:=nil; saly:=nil;   kam:=nil;kam2:=nil;
{uzivatele}
AssignFile(f,'uzivatele.xml');reset(f);
t:=NactiSoubor(f);CloseFile(f);
while t<>nil do
begin
 if t^.name='uzivatel'then
  begin
   jm:='';h:='';p:=false;
   for i:=1 to t^.att.count do
    begin
     if t^.att.items[i].name='jmeno'then jm:=t^.att.items[i].value;
     if t^.att.items[i].name='heslo'then h:=t^.att.items[i].value;
     if t^.att.items[i].name='psat'then p:=true;
    end;
   UzivatelPridat(jm,h,p);
  end;
 t:=t^.dalsi;
end;
ZnicTag(t);


{predstaveni}
AssignFile(f,'predstaveni.xml');reset(f);
t:=NactiSoubor(f);CloseFile(f);
while t<>nil do
begin
 if t^.name='predstaveni'then
  begin
   nazev:='';zanr:='';delka:='';popis:='';pozn:='';
   for i:=1 to t^.att.count do
    begin
     if t^.att.items[i].name='nazev'then nazev:=t^.att.items[i].value;
     if t^.att.items[i].name='zanr'then zanr:=t^.att.items[i].value;
     if t^.att.items[i].name='delka'then delka:=t^.att.items[i].value;
     if t^.att.items[i].name='popis'then popis:=t^.att.items[i].value;
     if t^.att.items[i].name='poznamka'then pozn:=t^.att.items[i].value;
    end;
   PredstaveniPridat(nazev,zanr,delka,popis,pozn);
  end;
 t:=t^.dalsi;
end;
ZnicTag(t);


{saly}
AssignFile(f,'saly.xml');reset(f);
t:=NactiSoubor(f);CloseFile(f);
while t<>nil do{----------- ZAKLADNI UROVEN ---------------------------------}
 begin
  if t^.name='sal'then
   begin
    nazev:='';x:='';y:='';
    for i:=1 to t^.att.count do
     begin
      if t^.att.items[i].name='nazev'then nazev:=t^.att.items[i].value;
      if t^.att.items[i].name='x'then x:=t^.att.items[i].value;
      if t^.att.items[i].name='y'then y:=t^.att.items[i].value;
     end;
    SalPridat(nazev,StrToInt(x),StrToInt(y));

    kam:=t; t:=t^.vnoreny;
    while t<>nil do{------ 1. UROVEN ----------------------------------------}
     begin
        if t^.name='neex'then
         begin
          x:='';y:='';
          for i:=1 to t^.att.count do
           begin
            if t^.att.items[i].name='x'then x:=t^.att.items[i].value;
            if t^.att.items[i].name='y'then y:=t^.att.items[i].value;
           end;
          SalPridatNeex(nazev,StrToInt(x),StrToInt(y));
         end
        else
        if t^.name='kpred'then
         begin
          nazevpr:=''; cena:=''; zacatek:='';
          for i:=1 to t^.att.count do
           begin
            if t^.att.items[i].name='nazev'then nazevpr:=t^.att.items[i].value;
            if t^.att.items[i].name='cena'then cena:=t^.att.items[i].value;
            if t^.att.items[i].name='zacatek'then zacatek:=t^.att.items[i].value;
           end;
          KPredstaveniPridat(nazev,nazevpr,cena,StringDoCasu(zacatek));
          kam2:=t;t:=t^.vnoreny;
          while t<>nil do{--- 2. UROVEN -------------------------------------}
           begin
              if t^.name='obs'then
               begin
                x:='';y:='';
                for i:=1 to t^.att.count do
                 begin
                  if t^.att.items[i].name='x'then x:=t^.att.items[i].value;
                  if t^.att.items[i].name='y'then y:=t^.att.items[i].value;
                 end;
                KPredstaveniKoupit(nazev,nazevpr,zacatek,StrToInt(x),StrToInt(y));
               end;
              t:=t^.dalsi;
           end;
          t:=kam2;{t:=t^.nad;}
         end;
        t:=t^.dalsi;
     end;
    t:=kam;{t:=t^.nad;   kdyz je t=nil, tak to prece nefunguje!!!}
   end;{of "if sal"}
  t:=t^.dalsi;
 end;
ZnicTag(t);

end;



destructor TServer.Znic;

  procedure ZnicUzivatele(var u:PUzivatel);
   begin
    if u<>nil then
     begin
      ZnicUzivatele(u^.dalsi);Dispose(u);u:=nil;
     end;
   end;

  procedure ZnicPredstaveni(var u:PPredstaveni);
   begin
    if u<>nil then
     begin
      ZnicPredstaveni(u^.dalsi);Dispose(u);u:=nil;
     end;
   end;

  procedure ZnicSaly(var s:PSal);
       procedure ZnicNeex(var n:PSedadlo);
        begin
         if n<>nil then
          begin ZnicNeex(n^.dalsi);Dispose(n);n:=nil;end;
        end;
       procedure ZnicKPred(var kp:PKPredstaveni);
        begin
         if kp<>nil then
          begin ZnicKPred(kp^.dalsi);Dispose(kp);kp:=nil;end;
        end;
   begin
    if s<>nil then
     begin
      ZnicNeex(s^.neex);
      ZnicKPred(s^.kpred);
      ZnicSaly(s^.dalsi);
      Dispose(s);s:=nil;
     end;
   end;
begin
ZnicUzivatele(uzivatele);
ZnicPredstaveni(predstaveni);
ZnicSaly(saly);
end;{of destructor}




{----------------- U Z I V A T E L ------------------------------------------}
function TServer.UzivatelExistuje(jm: string): boolean;
var akt:PUzivatel;
begin
result:=true;  akt:=uzivatele;
while akt<>nil do   if akt^.jmeno=jm then exit else akt:=akt^.dalsi;
result:=false;
end;

function TServer.UzivatelPridat(jm,h:string; p:boolean): boolean;
var n:PUzivatel;
begin
if UzivatelExistuje(jm)then begin result:=false;exit;end else result:=true;
new(n);
n^.jmeno:=jm; n^.heslo:=h; n^.psat:=p; n^.socket:=nil;
n^.dalsi:=uzivatele; uzivatele:=n;
end;

function TServer.UzivatelSmazat(jm: string): boolean;
var akt,pr:PUzivatel;
begin
if not UzivatelExistuje(jm)then begin result:=false;exit;end else result:=true;
pr:=nil;akt:=uzivatele;
while jm<>akt^.jmeno do begin pr:=akt;akt:=akt^.dalsi;end;

if pr=nil then{prvni}
 begin uzivatele:=akt^.dalsi; dispose(akt);exit;end;
pr^.dalsi:=akt^.dalsi; dispose(akt);
end;

function TServer.UzivatelUpravit(sjm, jm, h: string; p: boolean): boolean;
var pu:PUzivatel;
begin
if ((UzivatelExistuje(jm))and(jm<>sjm))or(not UzivatelExistuje(sjm))then
 begin result:=false;exit;end else result:=true;

pu:=Uzivatel(sjm);
pu^.jmeno:=jm; pu^.heslo:=h; pu^.psat:=p; 
end;

function TServer.UzivatelMuzePsat(soc:TCustomWinSocket):boolean;
var akt:PUzivatel;
begin
result:=false;
akt:=Uzivatel(soc);
if akt=nil then exit;
result:=akt^.psat;
end;


function TServer.UzivatelPripojen(jm:string): boolean;
var akt:PUzivatel;
begin
result:=true;
akt:=uzivatele;
while akt<>nil do
 begin
  if (akt^.jmeno=jm)then
   begin result:=akt^.socket<>nil; exit;end;
  akt:=akt^.dalsi;
 end;
result:=false;
end;



procedure TServer.UzivateleVsichni(var lb:TListBox);
var akt:PUzivatel;
begin
lb.Items.BeginUpdate;
lb.Items.Clear;
akt:=uzivatele;
while akt<>nil do  begin lb.Items.Add(akt^.jmeno);akt:=akt^.dalsi;end;
lb.Items.EndUpdate;
end;

function TServer.Uzivatel(jm:string):PUzivatel;
begin
if not UzivatelExistuje(jm)then begin result:=nil;exit;end;
Result:=uzivatele;
while result^.jmeno<>jm do result:=result^.dalsi;
end;

function TServer.Uzivatel(soc:TCustomWinSocket):PUzivatel;
var akt:PUzivatel;
begin
result:=nil;  if soc=nil then exit;
akt:=uzivatele;
while akt<>nil do
 begin
  if akt^.socket=soc then begin result:=akt;exit;end;
  akt:=akt^.dalsi;
 end;
end;


function TServer.UzivateleUloz: boolean;
var f:TextFile; akt:PUzivatel;
begin
result:=true;
AssignFile(f,'uzivatele.xml');
try
rewrite(f);
akt:=uzivatele;
while akt<>nil do
 begin
  write(f,'<uzivatel jmeno="'+akt^.jmeno+'" heslo="'+akt^.heslo+'"');
  if akt^.psat then write(f,' psat');
  writeln(f,'/>');
  akt:=akt^.dalsi;
 end;
closefile(f);
except
result:=false;
try closefile(f)except end;
exit;
end;
end;
{----------- END OF  U Z I V A T E L ----------------------------------------}





{----------- S A L Y --------------------------------------------------------}
function TServer.SalPridat(jm: string;x,y:integer):boolean;
var n:PSal;
begin
if SalExistuje(jm)then begin result:=false;exit;end else result:=true;
new(n);
n^.nazev:=jm; n^.x:=x;n^.y:=y;n^.neex:=nil;n^.kpred:=nil;
n^.dalsi:=saly; saly:=n;

OdeslatVsem(NapisSaly);
end;

function TServer.SalExistuje(jm: string): boolean;
var akt:PSal;
begin
result:=true;  akt:=saly;
while akt<>nil do   if akt^.nazev=jm then exit else akt:=akt^.dalsi;
result:=false;
end;


function TServer.SalyUloz: boolean;
var f:TextFile; akt:PSal; aktpr:PKPredstaveni; aktsed:PSedadlo;
begin
result:=true;
AssignFile(f,'saly.xml');
try
rewrite(f);
akt:=saly;
while akt<>nil do
 begin
  writeln(f,'<sal nazev="'+akt^.nazev+'" x="'+IntToStr(akt^.x)+'" y="'+IntToStr(akt^.y)+'">');

  aktsed:=akt^.neex;
  while aktsed<>nil do
   begin
    writeln(f,' <neex x="'+IntToStr(aktsed^.x)+'" y="'+IntToStr(aktsed^.y)+'"/>');
    aktsed:=aktsed^.dalsi;
   end;

  aktpr:=akt^.kpred;
  while aktpr<>nil do
   begin
    writeln(f,'  <kpred nazev="'+aktpr^.nazev+'" cena="'+
            aktpr^.cena+'" zacatek="'+CasDoStringu(aktpr^.zacatek)+'">');

    aktsed:=aktpr^.obsazene;
    while aktsed<>nil do
     begin
      writeln(f,'   <obs x="'+IntToStr(aktsed^.x)+'" y="'+IntToStr(aktsed^.y)+'"/>');
      aktsed:=aktsed^.dalsi;
     end;

    writeln(f,'  </kpred>');
    aktpr:=aktpr^.dalsi;
   end;

  writeln(f,'</sal>');
  akt:=akt^.dalsi;
 end;
closefile(f);
except
result:=false;
try closefile(f)except end;
exit;
end;
end;


procedure TServer.SalyVsechny(var lb: TListBox);
var akt:PSal;
begin
lb.Items.BeginUpdate;
lb.Items.Clear;
akt:=saly;
while akt<>nil do  begin lb.Items.Add(akt^.nazev);akt:=akt^.dalsi;end;
lb.Items.EndUpdate;
end;


function TServer.SalSmazat(jm: string): boolean;
var akt,pr:PSal;
begin
if not SalExistuje(jm)then begin result:=false;exit;end else result:=true;
pr:=nil;akt:=saly;
while jm<>akt^.nazev do begin pr:=akt;akt:=akt^.dalsi;end;

if pr=nil then
 begin saly:=akt^.dalsi; dispose(akt);exit;end;
pr^.dalsi:=akt^.dalsi; dispose(akt);

OdeslatVsem(NapisSaly);
end;


function TServer.SalPrejmenovat(sjm, jm: string): boolean;
var akt:PSal;
begin
if ((SalExistuje(jm))and(jm<>sjm))or(not SalExistuje(sjm))then
 begin result:=false;exit;end else result:=true;

akt:=saly;
while sjm<>akt^.nazev do akt:=akt^.dalsi;
akt^.nazev:=jm;

OdeslatVsem(NapisSaly);
end;


function TServer.Sal(jm: string): PSal;
begin
if not SalExistuje(jm)then begin result:=nil;exit;end;
Result:=saly;
while result^.nazev<>jm do result:=result^.dalsi;
end;


function TServer.SalPridatNeex(nazev:string; x,y:integer):boolean;
var n:PSedadlo;  ps:PSal;
begin
result:=false;
if not SalExistuje(nazev)then exit;
if SalExistNeex(nazev,x,y)then exit;

ps:=saly;
while ps<>nil do
 begin
  if ps^.nazev=nazev then break;
  ps:=ps^.dalsi;
 end;
{ v ps^.neex to je}
if (x<1)or(y<1)or(x>ps^.x)or(y>ps^.y)then exit;
New(n); n^.x:=x;n^.y:=y;
n^.dalsi:=ps^.neex;
ps^.neex:=n;
result:=true;

OdeslatVsem(NapisNeex(nazev));
end;


function TServer.SalExistNeex(nazev:string; x,y:integer): boolean;
var ps:PSal; psed:PSedadlo;
begin
result:=false;
if not SalExistuje(nazev)then exit;
ps:=saly;
while ps<>nil do
 begin
  if ps^.nazev=nazev then break; ps:=ps^.dalsi;
 end;
psed:=ps^.neex;
while psed<>nil do
 begin
  if (psed^.x=x)and(psed^.y=y)then begin result:=true;exit;end;
  psed:=psed^.dalsi;
 end;
end;


function TServer.SalSmazatNeex(nazev:string; x,y:integer):boolean;
var psed,pr:PSedadlo;  ps:PSal;
begin
result:=false;
if not SalExistuje(nazev)then exit;
if not SalExistNeex(nazev,x,y)then exit;

ps:=saly;
while ps<>nil do
 begin
  if ps^.nazev=nazev then break;
  ps:=ps^.dalsi;
 end;
{v ps^.neex to je}
psed:=ps^.neex; pr:=nil;
while psed<>nil do
 begin
  if (psed^.x=x)and(psed^.y=y)then break;
  pr:=psed; psed:=psed^.dalsi;
 end;
if psed=nil then exit;
result:=true;

if pr=nil then{prvni}
 begin ps^.neex:=psed^.dalsi; dispose(psed);exit;end;
{ne prvni ani jediny}
pr^.dalsi:=psed^.dalsi; dispose(psed);

OdeslatVsem(NapisNeex(nazev));
end;



function TServer.SalRozmery(nazev:string; x,y:integer):boolean;
var ps:PSal; psed,dalsi:PSedadlo;
begin
result:=false;
if not SalExistuje(nazev)then exit;

ps:=saly;
while ps<>nil do
 begin
  if ps^.nazev=nazev then break;
  ps:=ps^.dalsi;
 end;
if ps=nil then exit;
result:=true;
ps^.x:=x;ps^.y:=y;
psed:=ps^.neex;{jeste smazu sedadla, ktera "lezi mimo sal"}
while psed<>nil do
 begin
  dalsi:=psed^.dalsi;
  if (psed^.x>ps^.x)or(psed^.y>ps^.y)then SalSmazatNeex(nazev,x,y);
  psed:=dalsi;
 end;

OdeslatVsem(NapisNeex(nazev));
end;







function TServer.KPredstaveniExistuje(jmsal,jm:string;zac:TDateTime):boolean;
var ps:PSal; pkp:PKPredstaveni;
begin
result:=false;
ps:=Sal(jmsal); if ps=nil then exit;
pkp:=ps^.kpred;
while pkp<>nil do
 begin
  if (pkp^.nazev=jm)and(pkp^.zacatek=zac)then begin result:=true;exit;end;
  pkp:=pkp^.dalsi;
 end;
end;

function TServer.KPredstaveniPridat(jmsal,jm,cena:string;zac:TDateTime):boolean;
var n:PKPredstaveni; s:PSal;
begin
s:=Sal(jmsal);
if s=nil then begin result:=false;exit;end;
if KPredstaveniExistuje(jmsal,jm,zac)then begin result:=false;exit;end;
if not PredstaveniExistuje(jm)then begin result:=false;exit;end;
result:=true;
New(n); n^.nazev:=jm; n^.cena:=cena; n^.zacatek:=zac;
n^.obsazene:=nil;
n^.dalsi:=s^.kpred;
s^.kpred:=n;

OdeslatVsem(NapisKPVse(jmsal));
end;


function TServer.KPredstaveniSmazat(jmsal,jm:string;zac:TDateTime):boolean;
var akt,pr:PKPredstaveni; s:PSal;
begin
if not KPredstaveniExistuje(jmsal,jm,zac)then begin result:=false;exit;end;
s:=Sal(jmsal); if s=nil then begin result:=false;exit;end;
result:=true;

pr:=nil; akt:=s^.kpred;
while jm<>akt^.nazev do begin pr:=akt;akt:=akt^.dalsi;end;

if pr=nil then begin s^.kpred:=akt^.dalsi;dispose(akt);exit;end;
pr^.dalsi:=akt^.dalsi; dispose(akt);

OdeslatVsem(NapisKPVse(jmsal));
end;


function TServer.KPredstaveniUpravit(jmsal,sjm,jm,cena:string;szac,zac:TDateTime):boolean;
var pkp:PKPredstaveni;
begin
result:=false;
if not SalExistuje(jmsal)then exit;
if (not PredstaveniExistuje(sjm))or(not PredstaveniExistuje(jm))then exit;
if ((KPredstaveniExistuje(jmsal,jm,zac))and((jm<>sjm)and(zac<>szac)))
    or(not KPredstaveniExistuje(jmsal,sjm,szac))then exit;
pkp:=KPredstaveniJedno(jmsal,sjm,szac);
if pkp=nil then exit;
result:=true;

pkp^.nazev:=jm; pkp^.cena:=cena; pkp^.zacatek:=zac;

OdeslatVsem(NapisKPVse(jmsal));
end;


function TServer.KPredstaveniJedno(jmsal,jm:string;zac:TDateTime):PKPredstaveni;
var vysl:PKPredstaveni; ps:PSal;
begin
result:=nil; ps:=sal(jmsal); if ps=nil then exit;
if not KPredstaveniExistuje(jmsal,jm,zac)then exit;

vysl:=ps^.kpred;
while (vysl^.nazev<>jm)or(vysl^.zacatek<>zac) do
 vysl:=vysl^.dalsi;
Result:=vysl;
end;


procedure TServer.KPredstaveniVsechny(jmsal:string;var s:TStringGrid);
var ps:PSal; akt:PKPredstaveni; i,mez,nejm:integer;

 procedure Prohod(j,d:integer);
  var s1,s2,s3:string;
  begin
   s1:=s.Cells[0,j]; s2:=s.Cells[1,j]; s3:=s.Cells[2,j];
   s.Cells[0,j]:=s.Cells[0,d];  s.Cells[1,j]:=s.Cells[1,d];
   s.Cells[2,j]:=s.Cells[2,d];
   s.Cells[0,d]:=s1; s.Cells[1,d]:=s2; s.Cells[2,d]:=s3;
  end;

begin
s.RowCount:=2; s.Cells[0,1]:=''; s.Cells[1,1]:=''; s.Cells[2,1]:='';
ps:=Sal(jmsal); if ps=nil then exit;

akt:=ps^.kpred;
while akt<>nil do
 begin
  if s.Cells[0,1]<>'' then s.RowCount:=s.RowCount+1;
  s.Cells[0,s.RowCount-1]:=akt^.nazev;
  s.Cells[1,s.RowCount-1]:=DateTimeToStr(akt^.zacatek);
  s.Cells[2,s.RowCount-1]:=akt^.cena;
  akt:=akt^.dalsi;
 end;

{razeni primym vyberem}
for mez:=1 to s.RowCount-2 do
 begin
  nejm:=mez;
  for i:=mez+1 to s.RowCount-1 do
   if StrToDateTime(s.Cells[1,i])<StrToDateTime(s.Cells[1,nejm])then nejm:=i;
  Prohod(nejm,mez);
 end;
end;




function TServer.KPredstaveniKoupit(jmsal,jm,zac:string;x,y:integer):boolean;
var kp:PKPredstaveni; s:PSal; sed,n:PSedadlo; z:TDateTime;
begin
result:=false; z:=StringDoCasu(zac);
kp:=KPredstaveniJedno(jmsal,jm,z); if kp=nil then exit;
s:=Sal(jmsal); if s=nil then exit;
if (x<0)or(x>s^.x)or(y<0)or(y>s^.y)then exit;
if SalExistNeex(jmsal,x,y)then exit;
sed:=kp^.obsazene;
while sed<>nil do
 begin  if (sed^.x=x)and(sed^.y=y)then exit;  sed:=sed^.dalsi; end;
result:=true;

New(n); n^.x:=x; n^.y:=y;
n^.dalsi:=kp^.obsazene;
kp^.obsazene:=n;

OdeslatVsem(NapisKP(jmsal,jm,zac));
end;


function TServer.KPredstaveniOdkoupit(jmsal,jm,zac:string;x,y:integer):boolean;
var kp:PKPredstaveni; akt,pr:PSedadlo; z:TDateTime;
begin
result:=false; z:=StringDoCasu(zac);
kp:=KPredstaveniJedno(jmsal,jm,z); if kp=nil then exit;

pr:=nil; akt:=kp^.obsazene;
while (akt<>nil) do
 begin
  if (akt^.x=x)and(akt^.y=y)then break;
  pr:=akt; akt:=akt^.dalsi;
 end;

if akt=nil then exit;

result:=true;

if pr=nil then
 begin
  kp^.obsazene:=akt^.dalsi;Dispose(akt);
 end
else
 begin
  pr^.dalsi:=akt^.dalsi; Dispose(akt);
 end;
 
OdeslatVsem(NapisKP(jmsal,jm,zac));
end;






{----------- END OF  S A L Y --------------------------------------------------------}





{----------------- P R E D S T A V E N I -------------------------------------}
function TServer.PredstaveniExistuje(jm: string): boolean;
var akt:PPredstaveni;
begin
result:=true;  akt:=predstaveni;
while akt<>nil do   if akt^.nazev=jm then exit else akt:=akt^.dalsi;
result:=false;
end;

function TServer.PredstaveniPridat(nazev,zanr,delka,popis,poznamka:string):boolean;
var n:PPredstaveni;
begin
if PredstaveniExistuje(nazev)then begin result:=false;exit;end else result:=true;
new(n);
n^.nazev:=nazev; n^.zanr:=zanr; n^.popis:=popis; n^.poznamka:=poznamka;
n^.delka:=delka;
n^.dalsi:=predstaveni; predstaveni:=n;

end;


function TServer.PredstaveniSmazat(jm:string):boolean;
var akt,pr:PPredstaveni; ps:PSal; kp,zn,n:PKPredstaveni;

 procedure ZnicKP(p:PKPredstaveni);
  begin
   if p<>nil then begin ZnicKP(p^.dalsi);Dispose(p);p:=nil;end;
  end;

begin
if not PredstaveniExistuje(jm)then begin result:=false;exit;end else result:=true;
pr:=nil;akt:=predstaveni;
while jm<>akt^.nazev do begin pr:=akt;akt:=akt^.dalsi;end;

if pr=nil then{prvni}
 begin predstaveni:=akt^.dalsi; dispose(akt);exit;end;
pr^.dalsi:=akt^.dalsi; dispose(akt);

{smazani konkretnich predstaveni stejneho jmena}
ps:=saly;
while ps<>nil do
 begin
  kp:=ps^.kpred; zn:=nil;
  while kp<>nil do
   begin
    if (kp^.nazev<>jm)then
     begin
      new(n); n^:=kp^;
      if zn=nil then begin zn:=n;n^.dalsi:=nil;end
      else begin n^.dalsi:=zn;zn:=n;end;
     end;
    kp:=kp^.dalsi;
   end;
  if zn<>nil then
   begin
    ZnicKP(ps^.kpred); ps^.kpred:=zn;
    OdeslatVsem(NapisKPVse(ps^.nazev));
   end; 
  ps:=ps^.dalsi;
 end;

end;


function TServer.PredstaveniUpravit(sjm,nazev,zanr,delka,popis,poznamka:string):boolean;
var akt:PPredstaveni; s:PSal; kp:PKPredstaveni; b:boolean;
begin
if ((predstaveniExistuje(nazev))and(nazev<>sjm))or(not predstaveniExistuje(sjm))then
 begin result:=false;exit;end else result:=true;

akt:=predstaveni;
while sjm<>akt^.nazev do akt:=akt^.dalsi;
akt^.nazev:=nazev; akt^.zanr:=zanr; akt^.delka:=delka; akt^.popis:=popis;
akt^.poznamka:=poznamka;
if sjm=nazev then exit;

s:=saly;
while s<>nil do
 begin
  kp:=s^.kpred; b:=false;
  while kp<>nil do
   begin
    if kp^.nazev=sjm then begin kp^.nazev:=nazev;b:=true;end;
    kp:=kp^.dalsi;
   end;
  if b then OdeslatVsem(NapisKPVse(s^.nazev));
  s:=s^.dalsi;
 end;

end;


procedure TServer.PredstaveniVsechny(var lb:TListBox);
var akt:PPredstaveni;
begin
lb.Items.BeginUpdate;
lb.Items.Clear;
akt:=predstaveni;
while akt<>nil do  begin lb.Items.Add(akt^.nazev);akt:=akt^.dalsi;end;
lb.Items.EndUpdate;
end;

procedure TServer.PredstaveniVsechny(var lb:TComboBox);
var akt:PPredstaveni;
begin
lb.Items.BeginUpdate;
lb.Items.Clear;
akt:=predstaveni;
while akt<>nil do  begin lb.Items.Add(akt^.nazev);akt:=akt^.dalsi;end;
lb.Items.EndUpdate;
end;


function TServer.PredstaveniJedno(jm:string):PPredstaveni;
begin
if not PredstaveniExistuje(jm)then begin result:=nil;exit;end;
Result:=predstaveni;
while result^.nazev<>jm do result:=result^.dalsi;
end;

function TServer.PredstaveniUloz:boolean;
var f:TextFile; akt:PPredstaveni;
begin
result:=true;
AssignFile(f,'predstaveni.xml');
try
rewrite(f);
akt:=predstaveni;
while akt<>nil do
 begin
  write(f,'<predstaveni nazev="'+akt^.nazev+'" zanr="'+akt^.zanr+'" delka="');
  write(f,akt^.delka+'" popis="'+akt^.popis+'" poznamka="'+akt^.poznamka+'"');
  writeln(f,'/>');
  akt:=akt^.dalsi;
 end;
closefile(f);
except
result:=false;
try closefile(f)except end;
exit;
end;
end;
{----------- END OF  P R E D S T A V E N I ----------------------------------}



procedure TServer.OdeslatVsem(co: string);
var akt:PUzivatel;
begin
akt:=uzivatele;
while akt<>nil do
 begin
  if akt^.socket<>nil then akt^.socket.SendText(co);
  akt:=akt^.dalsi;
 end;
end;


function TServer.NapisSaly:string;
var p:PSal;
begin
result:='saly='; p:=saly;
while p<>nil do
 begin
  result:=result+p^.nazev+';';
  p:=p^.dalsi;
 end;
result:=result+'\';
end;


function TServer.NapisKPVse(s:string):string;
var pp:PKPredstaveni; ps:PSal;
begin
result:='salkpall='+s+';';
ps:=Sal(s); if ps=nil then begin result:=result+'\';exit;end;
pp:=ps^.kpred;
while pp<>nil do
 begin
  result:=result+pp^.nazev+';'+CasDoStringu(pp^.zacatek)+';'+pp^.cena+';';
  pp:=pp^.dalsi;
 end;
result:=result+'\';
end;

function TServer.NapisNeex(s:string):string;
var p:PSedadlo; ps:PSal;
begin
ps:=Sal(s); if ps=nil then begin result:='';exit;end;
result:='salneex='+s+';'+IntToStr(ps^.x)+';'+IntToStr(ps^.y)+';';
p:=ps^.neex;
while p<>nil do
 begin
  result:=result+IntToStr(p^.x)+';'+IntToStr(p^.y)+';';
  p:=p^.dalsi;
 end;
result:=result+'\';
end;



function TServer.NapisKP(sal,nazev,cas:string):string;
var p:PSedadlo; kp:PKPredstaveni;
begin
kp:=KPredstaveniJedno(sal,nazev,StringDoCasu(cas));
if kp=nil then begin result:='';exit;end;

result:='salkp='+sal+';'+nazev+';'+cas+';';
p:=kp^.obsazene;
while p<>nil do
 begin
  result:=result+IntToStr(p^.x)+';'+IntToStr(p^.y)+';';
  p:=p^.dalsi;
 end;
result:=result+'\';
end;

end.
